unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, TicTacToe, StdCtrls;

type
  TfrmBasic = class(TForm)
    grbBoardCont: TGroupBox;
    tttGame: TTicTacToe;
    menMainMenu: TMainMenu;
    menGame: TMenuItem;
    menLevel: TMenuItem;
    menNew: TMenuItem;
    menLevel1: TMenuItem;
    menLevel2: TMenuItem;
    menLevel3: TMenuItem;
    menLevel4: TMenuItem;
    menLevel5: TMenuItem;
    menFirst: TMenuItem;
    menUser: TMenuItem;
    menCPU: TMenuItem;
    menExit: TMenuItem;
    menAboutcomp: TMenuItem;
    lblNodesLabel: TLabel;
    lblNodes: TLabel;
    procedure menNewClick(Sender: TObject);
    procedure menLevelClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure menUserClick(Sender: TObject);
    procedure menCPUClick(Sender: TObject);
    procedure tttGameClickSquare(Square: Integer);
    procedure menExitClick(Sender: TObject);
    procedure menAboutcompClick(Sender: TObject);
  private
    { Private declarations }
    Playing  : Boolean;
    CPUFirst : Boolean;
  public
    { Public declarations }
  end;

var
  frmBasic: TfrmBasic;

implementation

{$R *.DFM}
procedure TfrmBasic.FormCreate(Sender: TObject);
begin
  Playing := true;   {We're playing a new game}
  CPUFirst := false; {User plays first}
  tttGame.Playing := Oh;
end;

procedure TfrmBasic.menAboutcompClick(Sender: TObject);
begin
  tttGame.About;
end;

procedure TfrmBasic.menNewClick(Sender: TObject);
begin
  tttGame.Clear;
  Playing := true; {New game has started}
  if CPUFirst then
    begin
      tttGame.Playing := Ex;
      tttGame.SetBoard(tttGame.CalcMove, Ex);
      lblNodes.Caption := inttostr(tttGame.TotalNodes);
    end
  else
    tttGame.Playing := Oh;
end;

procedure TfrmBasic.menExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfrmBasic.menLevelClick(Sender: TObject);
begin
  menLevel.Items[tttGame.Level-1].Checked := false;
  TMenuItem(Sender).Checked := true;
  tttGame.Level := TMenuItem(Sender).GroupIndex;
end;

procedure TfrmBasic.menUserClick(Sender: TObject);
begin
  menUser.Checked := true;
  menCPU.Checked  := false;
  tttGame.Playing := Oh;
  CPUFirst := false; {Player plays first}
  menNewClick(self);
end;

procedure TfrmBasic.menCPUClick(Sender: TObject);
begin
  menCPU.Checked  := true;
  menUser.Checked := false;
  tttGame.Playing := Ex;
  CPUFirst := true;  {CPU plays first}
  menNewClick(self);
end;

procedure TfrmBasic.tttGameClickSquare(Square: Integer);
begin
  if Playing then
    begin
      if tttGame.GetBoard(Square)=Blank then
        begin
          tttGame.SetBoard(Square, tttGame.User);
          case tttGame.State of
            Win : begin
                    Playing := false;
                    Application.MessageBox('User wins', 'Game result', MB_OK);
                    exit;
                  end;
            Draw: begin
                    Playing := false;
                    Application.MessageBox('It''s a draw', 'Game result', MB_OK);
                    exit;
                  end;
          end;
          tttGame.SetBoard(tttGame.CalcMove, tttGame.Playing);
          lblNodes.Caption := inttostr(tttGame.TotalNodes);
          case tttGame.State of
            Win : begin
                    Playing := false;
                    Application.MessageBox('CPU wins', 'Game result', MB_OK);
                    exit;
                  end;
            Draw: begin
                    Playing := false;
                    Application.MessageBox('It''s a draw', 'Game result', MB_OK);
                    exit;
                  end;
          end;
        end;
    end
  else
    beep;
end;

end.
